<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Admin User</title>
</head>
<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
<!-- Data Table-->
<link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

<body>
    <!-- Vùng header -->
    <div class="container">
        <div class="text-center">
            <h2>Danh sách người dùng đăng ký</h2>
        </div>
        <div class="form-group">
            <button class="btn btn-success" id="btn-add-user"><i class="fa fa-plus"></i>&nbsp; Thêm user</button>
        </div>
    </div>
    <!-- Vouche Data Table -->
    <div class="container">
        <table class="table table-bordered table-striped table-hover" id="user-table">
            <thead>
                <tr>
                    <th>ID</th>
                    <th>Full Name</th>
                    <th>Phone</th>
                    <th>Status</th>
                    <th>Action</th>
                </tr>
            </thead>
        </table>
    </div>
    <!-- Vùng Modal -->

    <!-- Create User modal -->
    <div>
        <div id="create-user-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="h5-modal-title">Create new User</h5>
                        <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <form>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-create-fullname">Full Name</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-create-fullname" name="fullname" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-create-phone">Phone</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-create-phone" name="phone" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-create-status">Status</label>
                                </div>
                                <div class="col-sm-8">
                                    <select class="form-control" name="" id="select-create-status">
                                        <option value="Level 0">Level 0</option>
                                        <option value="Level 1">Level 1</option>
                                        <option value="Level 2">Level 2</option>
                                        <option value="Level 3">Level 3</option>
                                    </select>
                                </div>
                            </div>

                        </form>
                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-secondary" id="btn-create-cancel" data-dismiss="modal">Cancel</button>
                        <button class="btn btn-primary" id="btn-create-user">Insert User</button>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <!-- Update user modal -->
    <div>
        <div id="update-user-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="h5-modal-title">Chi tiết User</h5>
                        <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <form>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-update-fullname">Full Name</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-fullname" name="fullname" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-update-phone">Phone</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-phone" name="phone" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="select-update-status">Status</label>
                                </div>
                                <div class="col-sm-8">
                                    <select class="form-control" name="" id="select-update-status">
                                        <option value="Level 0">Level 0</option>
                                        <option value="Level 1">Level 1</option>
                                        <option value="Level 2">Level 2</option>
                                        <option value="Level 3">Level 3</option>
                                    </select>
                                </div>
                            </div>

                        </form>
                    
                </div>
                <div class="modal-footer">
                    <button class="btn btn-secondary" id="btn-update-cancel" data-dismiss="modal">Cancel</button>
                    <button class="btn btn-primary" id="btn-update-user">Update User</button>
                </div>
            </div>
        </div>
    </div>
    </div>

    <!-- Delete confirm modal -->
    <div>
        <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="h5-modal-title">Confirm Xóa User</h5>
                        <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <label>Bạn có chắc chắn muốn xóa user này không?</label>
                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-danger" id="btn-confirm-delete-user">Xác nhận</button>
                        <button class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
</body>
<script>
    "use strict";
    $(document).ready(function () {
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gUSER_COLS = ["_id", "fullName", "phone", "status"];
        const gBASE_URL = "/api/v1/users"
        //
        const gUSER_ID_COL = 0
        const gUSER_FULLNAME_COL = 1
        const gUSER_PHONE_COL = 2
        const gBASE_STATUS_COL = 3
        const gUSER_ACTION_COL = 4
        // Khai báo dataTable
        var gUserTable = $("#user-table").DataTable({
            columns: [
                { data: gUSER_COLS[gUSER_ID_COL] },
                { data: gUSER_COLS[gUSER_FULLNAME_COL] },
                { data: gUSER_COLS[gUSER_PHONE_COL] },
                { data: gUSER_COLS[gBASE_STATUS_COL] },
                { data: gUSER_COLS[gUSER_ACTION_COL] },
            ],
            columnDefs: [
                { // định nghĩa lại cột action
                    targets: gUSER_ACTION_COL,
                    defaultContent: `<button id="btn-edit" class="btn btn-info">Sửa</button><button id="btn-delete" class ="btn btn-danger">Xóa</button>`
                }
            ]

        });
        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
        onPageLoading()
        // Gán sự kiện cho nút sửa
        $(document).on("click", "#btn-edit", function () {
            onBtnSuaClick(this)
        })
        // Gán sự kiện cho nút xóa
        $(document).on("click", "#btn-delete", function () {
            onBtnXoaClick(this)

        })
        // Gán sự kiện cho nút thêm user
        $(document).on("click", "#btn-add-user", function () {
            $("#create-user-modal").modal("show")
        })
        // Gán sự kiện cho nút insert user trong modal thêm user
        $(document).on("click", "#btn-create-user", function () {
            onBtnInsertUserClick()
        }
        )
        // Gán sự kiện cho nút update user trong modal update user
        $(document).on("click", "#btn-update-user", function () {
            onBtnConfirmUpdateClick()
        })
        // Gán sự kiện cho nút confirm xóa User
        $(document).on("click", "#btn-confirm-delete-user", function () {
            processingApiToDeleteUser()
        })
        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        function onPageLoading() {
            getAllUser()
        }
        //
        function onBtnInsertUserClick() {
            var vUserObject = {
                fullName: "",
                phone: "",
                status: "",
            }
            // B1 thu thập dữ liệu
            getDataToAddUser(vUserObject);
            // B2 Kiểm tra dữ liệu
            console.log(vUserObject)

            var vValidate = isDataValidateToAdd(vUserObject)
            if (vValidate == true) {
                // B3 Gọi Api 
                processingApiToAddUser(vUserObject)

            }
        }
        // Hàm xử lý sự kiện nút sửa
        function onBtnSuaClick(paramBtnSua) {
            var vRowSelected = $(paramBtnSua).parents("tr")
            var vDataRow = gUserTable.row(vRowSelected).data()
            var vId = vDataRow._id
            console.log(vDataRow)
            $("#btn-update-user").attr("id-object", `${vId}`)
            $("#input-update-fullname").val(vDataRow.fullName)
            $("#input-update-phone").val(vDataRow.phone)
            $("#select-update-status").val(vDataRow.status)
            $("#update-user-modal").modal("show")

        }
        function onBtnConfirmUpdateClick() {
            var vUserObject = {
                fullName: "",
                phone: "",
                status: "",
            }
            // B1 Thu thập dữ liệu 
            getDataToUpdateUser(vUserObject)
            // B2 Kiểm tra dữ liệu
            var vValidate = isDataValidateToAdd(vUserObject)
            if (vValidate == true) {
                //B3 Gọi Api
                processingApiToUpdateUser(vUserObject)
            }
        }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        // Hàm get dữ liệu để điền vào table
        function getAllUser() {
            $.ajax({
                url: gBASE_URL,
                type: "GET",
                success: function (paramResponseObject) {
                    //Điền dữ liệu vào table
                    // console.log(paramResponseObject)
                    loadDataToUserTable(paramResponseObject.result);
                },
                error: function (paramErr) {
                    console.log(paramErr.status);
                }
            })
        }
        // Hàm điền dữ liệu vào table
        function loadDataToUserTable(paramObject) {
            gUserTable.clear();
            gUserTable.rows.add(paramObject);
            gUserTable.draw();
        }
        //
        function getDataToAddUser(paramObject) {
            paramObject.fullName = $.trim($("#input-create-fullname").val())
            paramObject.phone = $.trim($("#input-create-phone").val())
            paramObject.status = $.trim($("#select-create-status").val())
        }
        //Hàm kiểm tra SĐT
        function isPhoneValidate(paramPhone) {
            var regexPhoneNumber = /(84|0[1|3|7|9])+([0-9]{8})\b/g;
            return paramPhone.match(regexPhoneNumber) ? true : false;
        }
        // 
        function isDataValidateToAdd(paramObject) {
            if (paramObject.fullName == "") {
                alert("Hãy nhập tên")
                return false
            }
            if (isPhoneValidate(paramObject.phone) == false) {
                alert("Sdt không hợp lệ")
                return false
            }
            return true
        }
        // Hàm gọi Api add user
        function processingApiToAddUser(paramObject) {
            $.ajax({
                url: gBASE_URL,
                contentType: "application/json;charset=UTF-8",
                data: JSON.stringify(paramObject),
                type: "POST",
                success: function (ResponseObject) {
                    displayAddSuccess(ResponseObject)

                },
                error: function (paramErr) {
                    console.log(paramErr.status);
                }
            })
        }
        //Hàm hiển thị khi thêm user thành công
        function displayAddSuccess(ResponseObject) {
            // Xóa trăng các Input và đặt select về giá trị ban đầu
            $("#input-create-fullname").val("")
            $("#input-create-phone").val("")
            $("#select-create-status").val("Level 1")
            $("#create-user-modal").modal("hide")

            alert(`
        Đã thêm user thành công `)
            // Load lại bảng
            getAllUser()
        }
                // Hàm thu thập dữ liệu cho việc cập nhật user
                function getDataToUpdateUser(paramObject) {
            paramObject.fullName = $.trim($("#input-update-fullname").val())
            paramObject.phone = $.trim($("#input-update-phone").val())
            paramObject.status = $.trim($("#select-update-status").val())
        }
        //
                //hàm gọi Api xử lý thêm update lên server
                function processingApiToUpdateUser(paramObject) {
            $.ajax({
                url: gBASE_URL +"/"+ $("#btn-update-user").attr("id-object"),
                contentType: "application/json;charset=UTF-8",
                data: JSON.stringify(paramObject),
                type: "PUT",
                success: function (ResponseObject) {
                    alert("Update user thành công")
            $("#update-user-modal").modal("hide")
            getAllUser()
                },
                error: function (paramErr) {
                    console.log(paramErr.status);
                }
            })
        }
                // Hàm xử lý sự kiện khi click nút xóa
                function onBtnXoaClick(paramBtnXoa) {
            $("#delete-confirm-modal").modal("show")
            // B1 Thu thập dữ liệu 
            var vRowSelected = $(paramBtnXoa).parents("tr")
            var vDataRow = gUserTable.row(vRowSelected).data()
            var vId = vDataRow._id
            $("#btn-confirm-delete-user").attr("id-object", `${vId}`)
        }
        function processingApiToDeleteUser() {
            $.ajax({
                url: gBASE_URL +"/"+ $("#btn-confirm-delete-user").attr("id-object"),
                type: "DELETE",
                success: function () {
                    // Hiển thị thông báo xóa thành công
                    alert("Đã xóa user thành công")
                    // Ẩn modal delete
                    $("#delete-confirm-modal").modal("hide")
                    // Tải lại bảng
                    getAllUser()

                },
                error: function (paramErr) {
                    console.log(paramErr.status);
                }
            })
        }
    })
</script>

</html>